/*
** a_spearofdestiny.cpp
**
**---------------------------------------------------------------------------
** Copyright 2012 Braden Obrzut
** All rights reserved.
**
** Redistribution and use in source and binary forms, with or without
** modification, are permitted provided that the following conditions
** are met:
**
** 1. Redistributions of source code must retain the above copyright
**    notice, this list of conditions and the following disclaimer.
** 2. Redistributions in binary form must reproduce the above copyright
**    notice, this list of conditions and the following disclaimer in the
**    documentation and/or other materials provided with the distribution.
** 3. The name of the author may not be used to endorse or promote products
**    derived from this software without specific prior written permission.
**
** THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
** IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
** OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
** IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
** INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
** NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
** DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
** THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
** (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
** THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
**---------------------------------------------------------------------------
**
**
*/

#include "actor.h"
#include "id_sd.h"
#include "thinker.h"
#include "wl_game.h"
#include "wl_play.h"
#include "g_shared/a_inventory.h"
#include "thingdef/thingdef.h"

class ASpearOfDestiny : public AInventory
{
	DECLARE_NATIVE_CLASS(SpearOfDestiny, Inventory)

	public:
		void Destroy()
		{
			gamestate.victoryflag = false;
			if(target && playstate == ex_newmap)
			{
				// Fixup new map warp position to toucher and not ourselves
				NewMap.x = target->x;
				NewMap.y = target->y;
				NewMap.angle = target->angle;
			}

			Super::Destroy();
		}

		bool TryPickup(AActor *toucher)
		{
			target = toucher;

			PlaySoundLocActor(pickupsound, toucher);
			gamestate.victoryflag = true;

			SetState(FindState(NAME_Pickup));
			SetPriority(ThinkerList::VICTORY);
			return false;
		}
};
IMPLEMENT_CLASS(SpearOfDestiny)
